<?php
// Contains code from: http://php.net/manual/en/function.phpinfo.php
// Additional code: Copyright (c) 2011-2013 White Fir Design 
// White Fir Design code is released under the GNU General Public License

echo "<html>\n<head>\n<title>Server Software Version Check by White Fir Design (www.whitefirdesign.com)</title>\n<meta name=\"robots\" content=\"noindex\" />\n</head>\n<body>\n\n<p><b>Server Software Version Check</b> by <a href=\"http://www.whitefirdesign.com\">White Fir Design</a></p>\n\n";

// Checks server version
echo "<h1>Server</h1> ";
echo "<p><b>Version</b>: ";
echo getenv('SERVER_SOFTWARE');
echo "</p>\n\n";

// Checks PHP version
echo "<h1>PHP</h1> ";
echo "<p><b>Version:</b> ";
echo phpversion();
echo "</p>\n\n";

// Checks MySQL version
echo "<h1>MySQL/MariaDB</h1> ";
if (function_exists('mysql_connect')) {
	if (isset($_POST['mysql_host'])) {
		$host = $_POST['mysql_host'];
		$username = $_POST['mysql_username'];
		$password = $_POST['mysql_password'];
		$link = @mysql_connect($host,$username,$password);
		if ($link) {
			$mysql = mysql_query("SELECT VERSION()");
			$mysqlversion = mysql_fetch_row($mysql);
		}
		echo "<p><b>Version</b>: ";
		echo $mysqlversion[0];
		echo "</p>\n\n";
		echo '<form method="post" action="'.basename(__FILE__).'">';
		echo 'Database host: <input name="mysql_host" value="" /><br>';
		echo 'Database username: <input name="mysql_username" value="" /><br>';
		echo 'Database password: <input name="mysql_password" value="" autocomplete="off" /><br>';
		echo '<input type="submit" value="Get MySQL Info" />';
		echo "</form>";
		echo "\n\n";
	}
	else {
	echo '<form method="post" action="'.basename(__FILE__).'">';
	echo 'Database host: <input name="mysql_host" value="" /><br>';
	echo 'Database username: <input name="mysql_username" value="" /><br>';
	echo 'Database password: <input name="mysql_password" value="" autocomplete="off" /><br>';
	echo '<input type="submit" value="Get MySQL Info" />';
	echo "</form>";
	echo "\n\n";
	}
}
else
	echo "<p>Does not appear to be installed.</p>\n\n";

// Checks PostgreSQL version
echo "<h1>PostgreSQL</h1> ";
if (function_exists('pg_connect'))
{
	if (isset($_POST['postgresql_host'])) {
		$host = $_POST['postgresql_host'];
		$username = $_POST['postgresql_username'];
		$password = $_POST['postgresql_password'];
		$postgresql = pg_connect("host=".$host." user=".$username." password=".$password);
		$postgresqlversion = pg_version($postgresql);
		echo "<p><b>Version</b>: ";
		echo $postgresqlversion['server'];
		echo "</p>\n\n";
		echo '<form method="post" action="'.basename(__FILE__).'">';
		echo 'Database host: <input name="postgresql_host" value="" /><br>';
		echo 'Database username: <input name="postgresql_username" value="" /><br>';
		echo 'Database password: <input name="postgresql_password" value="" autocomplete="off" /><br>';
		echo '<input type="submit" value="Get PostgreSQL Info" />';
		echo "</form>";
		echo "\n\n";
	}
	else {
		echo '<form method="post" action="'.basename(__FILE__).'">';
		echo 'Database host: <input name="postgresql_host" value="" /><br>';
		echo 'Database username: <input name="postgresql_username" value="" /><br>';
		echo 'Database password: <input name="postgresql_password" value="" autocomplete="off" /><br>';
		echo '<input type="submit" value="Get PostgreSQL Info" />';
		echo "</form>";
		echo "\n\n";
	}
}
else
	echo "<p>Does not appear to be installed.</p>\n\n";

// Checks OpenSSL version if installed, can check other phpinfo() variable
ob_start();
phpinfo();
$phpinfo = array('phpinfo' => array());
if(preg_match_all('#(?:<h2>(?:<a name=".*?">)?(.*?)(?:</a>)?</h2>)|(?:<tr(?: class=".*?")?><t[hd](?: class=".*?")?>(.*?)\s*</t[hd]>(?:<t[hd](?: class=".*?")?>(.*?)\s*</t[hd]>(?:<t[hd](?: class=".*?")?>(.*?)\s*</t[hd]>)?)?</tr>)#s', ob_get_clean(), $matches, PREG_SET_ORDER)) {
    foreach($matches as $match)
        if(strlen($match[1]))
            $phpinfo[$match[1]] = array();
        else if(isset($match[3])) {
			$arraykey = array_keys($phpinfo);
			$phpinfo[end($arraykey)][$match[2]] = isset($match[4]) ? array($match[3], $match[4]) : $match[3];
		}
        else {
		$arraykey = array_keys($phpinfo);
            $phpinfo[end($arraykey)][] = $match[2];
		}
}
echo "<h1>OpenSSL</h1> ";
if (isset($phpinfo["openssl"]["OpenSSL Version"])) {
	echo "<p><b>Version</b>: ";
	echo $phpinfo["openssl"]["OpenSSL Version"];
	echo "</p>\n\n";
}
else if (isset($phpinfo["openssl"]["OpenSSL Library Version"])) {
	echo "<p><b>Version</b>: ";
	echo $phpinfo["openssl"]["OpenSSL Library Version"];
	echo "</p>\n\n";
}
else
	echo "<p>Does not appear to be installed.</p>\n\n";

echo "</body>\n</html>";

?>
